// ********************************************************
//
// Misc functions externalized to be reused
// include them using "include directive"
//
// Prerequisites : uses CFG, User, FGroup, FBase
// !!!!!!!!!!!!!   must be declared in main source that
// !!!!!!!!!!!!!   includes this one
//
// by fabian@lucchi.me / BackToTheRoots BBS
// bttr.it-awareness.ch:2332
//
// 25.01.2017   1.0   First write, for Mystic 1.12 A31
//
// ********************************************************

//
// GetFB_Filename : String                    // get active filebase filename
// StopWithMessage(String)                    // Write log in nodex file, display error and go back to main menu
// AddLog(String)                             // Standardized log trace
//

// ***************************************************************************
// Add a trace in active node log file with custom message, with script&version name
// ***************************************************************************
Procedure AddLog(sLogMessage : String);
Begin
  SysopLog(cssMPL_Name+'('+cssMPL_Version+') - '+sLogMessage);
End;

// ***************************************************************************
// Custom but standardized error message for abnormal program termination
// ***************************************************************************
Procedure StopWithMessage(sCrashMessage : String);
Begin
  ClrScr;
  GotoXY(1, 12);
  WriteLn('|20|14'+cssMPL_Name+' v'+cssMPL_Version+' - Crash!!! o_O');
  WriteLn('|20|14Error : '+sCrashMessage);
  WriteLn('|16|07');

  // Leave a trace in the nodex.log file for further investigation
  AddLog(sCrashMessage);

  Pause;
  MenuCmd('GO', 'main'); // Back to main menu, by default
  Halt;
End; // StopWithMessage

// ***************************************************************************
// Get Active filebase filename (without extension)
// ie: tinysbbs-bbssoft
// ***************************************************************************
//Function GetFB_Filename : String;
//Var
//  frecBase          : File;
//  recBase           : TFileBase;
//  bFound            : Boolean = False;
//Begin
//  GetThisUser;

// GetFB_Filename    := ''; // By default, return empty string

  // Open fbases.dat to read all existing bases until we found the
  // active one
//  fAssign(frecBase, CFGDataPath+cssMystic_System_FB, 66);
//  fReset(frecBase);

//  While Not(fEOF(frecBase)) Or Not(bFound) Do Begin
//    fReadRec(frecBase, recBase);

    // UserFBase contains the active base ID for the logged on user
    // It is not the same ID that what GetFBase(id) function needs :(
//    If recBase.wIndex=UserFBase Then Begin
//      // We found the active file base
//      GetFB_Filename := recBase.sFilename;
//      bFound          := True;
//    End; // If recBase.wIndex
//  End; // While Not(fEOF)
//  fClose(frecBase);
//End; // Function GetFileBaseCode : Integer

// ***************************************************************************
// Format a file size to a restricted length with
// short human readable units
//
// iNumberToFormat : Number to format accordingly
// iFieldSize      : Length of resulting string
// ***************************************************************************
Function FormatFileSize(iNumberToFormat, iFieldSize : LongInt) : String;
Var
  iLength : Integer;
  sResult : String;
Begin
  Case iNumberToFormat Of
    0..999              : Begin
                            sResult := Int2Str(iNumberToFormat)+'B';
                          End;
    1000..999999        : Begin
                            sResult := Int2Str(iNumberToFormat / 1000)+'K';
                          End;
    1000000..999999999 : Begin
                            sResult := Int2Str(iNumberToFormat / 1000 / 1000)+'M';
                          End;
  Else                    Begin
                            sResult := Int2Str(iNumberToFormat / 1000 / 1000 / 1000)+'G';
                          End;

  iLength := Length(sResult);

  If iLength < iFieldSize Then Begin
    sResult := StrRep(' ', iFieldSize-iLength) + sResult;
  End; // if iLength <

  FormatFileSize := sResult;
End;
