// ********************************************************
//
// Record types to be included in files requiring direct
// internal mystic's file access
// by fabian@lucchi.me / BackToTheRoots BBS
// bttr.it-awareness.ch:2332
//
// 23.01.2017   1.0   First write, for Mystic 1.12 A31
// 23.04.2018   1.1   Patch for Mystic 1.12 A39, new fbases.dat & mbases.dat
//
// ********************************************************

Const
  cssMystic_System_FB   = 'fbases.dat';
  cssMystic_System_MB   = 'mbases.dat';
  cssMystic_System_FG   = 'groups_f.dat';
  cssMystic_System_MG   = 'groups_g.dat';

Type
  TMys_FileList = Record
                    sFileName   : String[70];
                    liSize      : LongInt;
                    liDateTime  : LongInt;
                    sUploader   : String[30];
                    byFlags     : Byte;
                    liDownloads : LongInt;
                    byRating    : Byte;
                    liDescPtr   : LongInt;
                    byDescLines : Byte;
                  End;

Type
  TUser         = Record    // Since mplc seems to be limited to 40 fields in one record, I grouped what is not mandatory
                    liUniqueID          : LongInt;                                // permanent user number
                    liFlags             : LongInt;                                // User Flags bitmap
                    sPassword           : Array[1..101] Of Byte;
                    sHandle             : String[30];                             // Handle
                    sRealName           : String[30];                             // Real name
                    asBlock_1           : String[157];
//                    sAddress            : String[30];                             // Address
//                    sCity               : String[25];                             // City
//                    sZipCode            : String[9];                              // Zipcode
//                    sHomePhone          : String[15];                             // Home Phone
//                    sDataPhone          : String[15];                             // Data phone
//                    liBirthday          : LongInt;                                //
//                    cGender             : Char;                                   // M/F/U
//                    sEmail              : String[60];
                    asOptionData        : Array[1..10] of String[60];
                    asBlock_2           : String[261];                            // Te replace 4 next fiels
//                  sUserInfo           : String[30];
//                  sTheme              : String[20];
//                  afAF1               : String[26];
//                  afAF2               : String[26];
//                  liSecurity          : LongInt;
                    asBlock_2_2         : String[33];
//                  liExpires           : LongInt;
//                  byExpiresTo         : Byte;
//                  liLastPWChange      : LongInt;
//                  sStartMenu          : String[20];
//                  sArchive            : String[4];
//                  bQwkFiles           : Boolean;
//                  byDateType          : Byte;
//                  byScreenSize        : Byte;
//                  byScreenCols        : Byte;
                  asBlock_4           : String[197];
//                  sPeerIP             : String[45];
//                  sPeerHost           : String[80];
//                  sPeerCountry        : String[60];
//                  liFirstOn           : LongInt;                                // Date/Time of First Call
//                  liLastOn            : LongInt;                                // Date/Time of Last Call
//                  liCalls             : LongInt;                                // Number of calls to BBS
//                  wCallsToday         : Word;                                   // Number of calls today
//                  wDLs                : Word;                                   // # of downloads
//                  wDLsToday           : Word;                                   // # of downloads today
//                  aliBlock_5          : Array[1..7] Of LongInt;
                    liDLk               : LongInt;                                // # of downloads in K
                    liDLkToday          : LongInt;                                // # of downloaded K today
                    liULs               : LongInt;                                // total number of uploads
                    liULk               : LongInt;                                // total number of uploaded K
                    liPosts             : LongInt;                                // total number of msg posts
                    liEmails            : LongInt;                                // total number of sent email
                    iTimeLeft           : Integer;                                // time left online for today
                    iTimeBank           : Integer;                                // number of mins in timebank
//                  awBlock_7           : Array[1..4] Of Word;
                    wLastFBase          : Word;                                   // Last file base
                    wLastMBase          : Word;                                   // Last message base
                    wLastMGroup         : Word;                                   // Last group accessed
                    wLastFGroup         : Word;                                   // Last file group accessed
                    abyVote             : Array[1..99] of Byte;                   // Voting booth data
                    byEditType          : Byte;                                   // 0 = Line, 1 = Full, 2 = Ask
                    byFileList          : Byte;                                   // 0 = Normal, 1 = Lightbar
                    bSigUse             : Boolean;                                // Use auto-signature?
                    liSigOffset         : LongInt;                                // offset to sig in AUTOSIG.DAT
                    bySigLength         : Byte;                                   // number of lines in sig
                    bHotKeys            : Boolean;                                // does user have hotkeys on?
                    byMReadType         : Byte;                                   // 0 = line 1 = full 2 = ask
//                  abBlock_8           : Array[1..4] Of Boolean;
                    bUseLBIndex         : Boolean;                                // use lightbar index?
                    bUseLBQuote         : Boolean;                                // use lightbar quote mode
                    bUseLBMIdx          : Boolean;                                // use lightbar index in email?
                    bUseFullChat        : Boolean;                                // use full screen teleconference
                    liCredits           : LongInt;
                    cProtocol           : Char;
                    byQwkExtended       : Boolean;
                    liQwkNetwork        : LongInt;
                    liEmailValDate      : LongInt;
                    abyReserved         : Array[1..108] of Byte;
                  End;

Type
  TGroupBase      = Record
                      iUniqueID    : LongInt;
                      sName        : String[30];
                      sACS         : String[30];
                      bHidden      : Boolean;
                    End;

Type
  TMessageBase    = Record
                      wIndex       : Word;
                      sName        : String[60];
                      sQWKName     : String[13];
                      sNewsName    : String[60];
                      sFilename    : String[40];
                      sPath        : String[80];
                      byNetType    : Byte;
                      byReadType   : Byte;
                      byListType   : Byte;
                      sListACS     : String[30];
                      sReadACS     : String[30];
                      sPostACS     : String[30];
                      sSysopACS    : String[30];
                      sListACS     : String[30];
                      sPostACS     : String[30];
                      byColQuote   : Byte;
                      byColText    : Byte;
                      byColTear    : Byte;
                      byColOrigin  : Byte;
                      byColKludge  : Byte;
                      bNetAddr     : Byte;
                      sOrigin      : String[50];
                      byDefNScan   : Byte;
                      byDefQScan   : Byte;
                      liMaxMsgs    : LongInt;
                      wMaxAge      : Word;
                      sHeader      : String[20];
                      sRTemplate   : String[20];
                      sITemplate   : String[20];
                      liFlags      : LongInt;
                      liCreated    : LongInt;
                      sEchoTag     : String[40];
                      liQWKNetId   : LongInt;
                      wQWKConfId   : Word;
                      abReserved   : Array[1..136] Of Byte;
                    End;

Type
  TFileBase       = Record
                      wIndex       : Word;
                      sName        : String[60];                                // 1.1
                      sFTPName     : String[60];
                      sFilename    : String[40];
                      sDispFile    : String[20];
                      sTemplate    : String[20];
                      sListACS     : String[30];
                      sFTPAcs      : String[30];
                      sDownloadACS : String[30];
                      sUploadACS   : String[30];
                      sHatchACS    : String[30];
                      sSysopACS    : String[30];
                      sPassACS     : String[30];
                      sPath        : String[80];
                      byDefScan    : Byte;
                      liFlags      : LongInt;
                      liCreated    : LongInt;
                      byNetAddr    : Byte;
                      sEchoTag     : String[40];
                      sListEACS    : String[30];                                // 1.1
                      abReserved   : Array[1..53] Of Byte;
                    End;

